Subject: [DNA] Early patches for draft-pentland-dna-protocol-00

From: Greg Daley <[email-masked]>
Date: Tue, 28 Jun 2005 22:34:19 +1000

Dear WG,

Considering Syam's good news about the LinkID implementation, 
I'd like to pass on some code.

Here's a partial implementation for the protocol
proposed in:

draft-pentland-dna-protocol-00.txt

With the modifications discussed in issues on-list.

It works on Linux 2.4.8.1 with an unmodified kernel.
We've been using Cisco Aironet/350 cards which support
wireless events.

The host portion is dual-licensed (BSD with one way GPL
trapdoor) pair of RS transmission tools, one of which 
sends a single RS, and another which waits for a 
Link-UP event from the wireless LAN system:

http://www.ctie.monash.edu.au/dna/eventrs0.01.tgz

The router portion is a patch against RADVD 0.7.3:

http://www.ctie.monash.edu.au/dna/DNARADVD.protocol-00.0.01.patch

What's there:

Host (Userspace)- 
    :: source address transmission
    SLLAO transmission
    TSLLAO transmission
    Landmark transmission
    Link-Layer events using Linux Wireless Extensions

Router (Radvd/Userspace)-
    SLLAO processing
    TSLLAO processing (experimental - bug for many neighbours)
    Modified RA scheduling algorithm for simultaneous RAs
    Token Bucket for FastRAs
    Hash Based Fast RA.
    Unicast Responses for RAs
    Landmark Responses
    CompleteRA 

What's missing: 

Host (Userspace)- 
    The response matching on the host
    dynamic landmark selection for eventrs
    actually setting interface flags for optimistic (not in scope)
    SEND (not in scope)

Router (Radvd/Userspace)-
    Strict packet and bounds checking *you've been warned*
    SEND (not in scope)

I'll see if I can come out with an updated version of the 
host code this week with the response matching component.

Instructions:

Installation instructions for the RADVD patch are available here:

http://www.ctie.monash.edu.au/warchive/dna-dt/2005-05/msg00181.html

Please be aware that I've changed the name of the patch to 
DNARADVD.protocol-00.0.01.patch to avoid confusion about which
proposal this covers.

Warning: this requires a recent version of OpenSSL, for Hash FastRA.
 
Host:

tar xzvf eventrs0.01.tgz
cd eventrs0.01
more README.txt
su root
./sendrs tap0 -s -t -L 3ffe:8001:0012:0a88

Please note the leading zeros and colons.

Happy hacking.

Greg